/*
          This file is part of Sandia National Laboratories
          copyrighted software.  You are legally liable for any
          unauthorized use of this software.

          NOTICE:  The United States Government has granted for
          itself and others acting on its behalf a paid-up,
          nonexclusive, irrevocable worldwide license in this
          data to reproduce, prepare derivative works, and
          perform publicly and display publicly.  Beginning five
          (5) years after June 5, 1997, the United States
          Government is granted for itself and others acting on
          its behalf a paid-up, nonexclusive, irrevocable
          worldwide license in this data to reproduce, prepare
          derivative works, distribute copies to the public,
          perform publicly and display publicly, and to permit
          others to do so.

          NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED
          STATES DEPARTMENT OF ENERGY, NOR SANDIA CORPORATION,
          NOR ANY OF THEIR EMPLOYEES, MAKES ANY WARRANTY, EXPRESS
          OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR
          RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS, OR
          USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT, OR
          PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
          INFRINGE PRIVATELY OWNED RIGHTS.
*/

/**=========================================================================**/
bool readIntParam(char *string, int& iparam) {
    FILE *ifp = fopen("driver.in","r");
    char line[64],str[64];

    if(!ifp) return(false);

    fgets(line,64,ifp);
    while(!feof(ifp)){
        sscanf(line,"%s %d",str,&iparam);
        if (!strcmp(str,string)) {
            fclose(ifp);
            return(true);
        }
        fgets(line,64,ifp);
    }
    
    fclose(ifp);
    return(false);
}


/**=========================================================================**/
bool readBoolParam(char *string, bool& bparam) {
    FILE *ifp = fopen("driver.in","r");
    char line[64], str[64], str2[64];

    if (!ifp) return(false);

    fgets(line,64,ifp);

    while(!feof(ifp)){
        sscanf(line,"%s %s",str,str2);
        if (!strcmp(str,string)) {
            if (!strcmp("true",str2)) bparam = true;
            else bparam = false;
            fclose(ifp);
            return(true);
        }
        fgets(line,64,ifp);
    }
    
    fclose(ifp);
    return(false);
}


/**=========================================================================**/
bool readDoubleParam(char *string, double& dparam) {
    FILE *ifp = fopen("driver.in","r");
    char line[64],str[64];

    if (!ifp) return(false);

    fgets(line,64,ifp);
    while(!feof(ifp)){
        sscanf(line,"%s %le",str,&dparam);
        if (!strcmp(str,string)){
            fclose(ifp);
            return(true);
        }
        fgets(line,64,ifp);
    }
    
    fclose(ifp);
    return(false);
}
