      program genmat
      implicit none 

      integer n, nx, ny, nz
      character matfile*20

c     code to read in nx,ny, etc. 
      print *, 'enter the mesh dimensions nx, ny '
      read (5,*) nx, ny
      print *, 'enter name of file to output matrix '
      read(*,'(a20)') matfile

*     ******************************************
*     set up matrix dimensions
*     ******************************************

*     nx = 15
*     ny = 15
      n = nx*ny
      nz = nx*ny + (nx-1)*ny*2 + nx*(ny-1)*2

      call create(n,nx,ny,nz,matfile)

      print *,'Matrix generation successful.'

      stop
      end


      subroutine create(n,nx,ny,nz,matfile)
      implicit none
*     vars used by MATPDE
      integer n,nx,ny,nz
      integer rowptr(n+1), colind(nz)
      double precision a(nz), rhs(n)
*     vars used by PRTMT
      integer job
      integer ifmt, iounit
      character title*72, key*8, type*3, guesol*2
      character matfile*20

*     ******************************************
*     first, call MATPDE to generate the problem
*     ******************************************
      call MATPDE(n,nx,ny,a,rowptr,colind,rhs)

*     ******************************************************
*     now call SPARSKIT2's PRTMT to write from compressed
*     sparse column to Harwell-Boeing format
*     ******************************************************
      title = "my favorite test matrix"
      key = " " 
      type = "RUA"
*     no exact solution provided; no initial guess provided
      guesol = "NN"
*     write the matrix and one right-hand side
      job = 3
      ifmt = 10
      iounit = 7
      open (unit=7,file=matfile)
      call prtmt(n,n,a,colind,rowptr,rhs,guesol,title,key,type,
     c ifmt,job,iounit)

      return
      end


